=== debian/changelog ===
z3 (4.8.12-3.1build1) noble; urgency=high

  * No change rebuild against frame pointers and time_t.

 -- Julian Andres Klode <juliank@ubuntu.com>  Mon, 22 Apr 2024 11:52:27 +0200

z3 (4.8.12-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * riscv64: link against -latomic (Closes: #1025343)

 -- Manuel A. Fernandez Montecelo <mafm@debian.org>  Wed, 01 Feb 2023 13:06:03 +0100

z3 (4.8.12-3) unstable; urgency=medium

  * Do not use SSE2 unconditionally on i386
    (Closes: #1020802, #1020516, #1016658, #1021926)

 -- Karo Gyoker <karogyoker2+debbug@gmail.com>  Fri, 21 Oct 2022 19:24:40 +0200

z3 (4.8.12-2) unstable; urgency=medium

  * Fix a typo. Thanks to Boyuan Yang for the patch
    (Closes: #1018962)

 -- Sylvestre Ledru <sylvestre@debian.org>  Sat, 03 Sep 2022 11:48:53 +0200

z3 (4.8.12-1) unstable; urgency=medium

  [ Debian Janitor ]
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

  [ Fabian Wolff ]
  * New upstream release.
  * Upgrade to Standards-Version 4.6.0.
  * Update years in debian/copyright.
  * Update 00-intrinsics.patch and refresh 01-soname.patch.

 -- Fabian Wolff <fabi.wolff@arcor.de>  Sat, 11 Sep 2021 17:58:23 +0200
